# Code written by Theodore Lindsey for his master's thesis.
# Fall 2016
# Liscensed under the GNU Lesser General Public License v3
from math import floor, factorial

def union(sets):
    if len(sets) == 0:
        return set()
    elif len(sets) == 1:
        return sets[0]
    elif len(sets) == 2:
        return sets[0].union(sets[1])
    else:
        return union([sets[0].union(sets[1])] + sets[2:])

def intersection(sets):
    if len(sets) == 0:
        return set()
    elif len(sets) == 1:
        return sets[0]
    elif len(sets) == 2:
        return sets[0].intersection(sets[1])
    else:
        return intersection([sets[0].intersection(sets[1])] + sets[2:])

def isnum(s):
    if s is None:
        return False
    try:
        float(s)
        return True
    except ValueError:
        return False

def progressBar(percnt):
    width = 50
    width = width / 100
    percnt = floor(100*percnt)
    retstr = "\r{:3d}% [".format(floor(percnt))
    retstr += "".join(["=" if x < floor(percnt*width) else " " for x in range(floor(100*width))])
    retstr += "]"
    return retstr

def fileLineCount(filename):
    with open(filename) as f:
        num_lines = sum(1 for line in f)
    return num_lines

def nCr(n,r):
    f = factorial
    return (f(n) / f(n-r)) / f(r)
